c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


      subroutine ini_divide(kind_p)
      include 'common.3D'
      
      
      do i=1,nct_local
         
         nc(i,kind_p)  = 0
         ibox(i,kind_p,1:nplink_max)  = 0
      
      enddo
      
      if(kind_p.eq.1.or.kind_p.eq.2)then
        !-- Clear nc(ii,mkind=1) array of imported BPs for X-Dir Partitioning --
        do lz=1,ncz_local
        do ly=1,ncy_local
          
          lx = 1            !First vertical sheet
          j1 = lx + (ly-1)*ncx_local + (lz-1)*nsheet_local
          nc(j1,1)=0
          !ip(j1,1)  = 0       !??????????
          
          lx = ncx_local    !Last vertical sheet
          j1 = lx + (ly-1)*ncx_local + (lz-1)*nsheet_local
          nc(j1,1)=0
          !ip(j1,1)  = 0       !??????????
        
        end do
        end do

        !-- Clear nc(ii,mkind=1) array of imported BPs for Z-Dir Partitioning --       
        do lx=1,ncx_local
        do ly=1,ncy_local
          
          lz = 1            !First horizontal sheet
          j1 = lx + (ly-1)*ncx_local + (lz-1)*nsheet_local
          nc(j1,1)=0
          !ip(j1,1)  = 0       !??????????
          
          lz = ncz_local    !Last horizontal sheet
          j1 = lx + (ly-1)*ncx_local + (lz-1)*nsheet_local
          nc(j1,1)=0
          !ip(j1,1)  = 0       !??????????
        
        end do
        end do
      
        !-- Clear nc(ii,mkind=1) array of imported BPs for Y-Dir Partitioning --       
        do lx=1,ncx_local
        do lz=1,ncz_local
          
          ly = 1            !First horizontal row
          j1 = lx + (ly-1)*ncx_local + (lz-1)*nsheet_local
          nc(j1,1)=0
          !ip(j1,1)  = 0       !??????????
          
          ly = ncy_local    !Last horizontal row
          j1 = lx + (ly-1)*ncx_local + (lz-1)*nsheet_local
          nc(j1,1)=0
          !ip(j1,1)  = 0       !??????????
        
        end do
        end do
      

      endif


      return

      end