c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine movingObjects(i_midPoint)
c
      include 'common.3D'
      
      
c      itime_check = 10e8   !0
c      if(itime.ge.itime_check.and.rank_id.eq.2)then
c        print*
c        print*,'In movingOBJECTS.f '
c        print*,'itime               ',itime
c        print*,'i_midPoint          ',i_midPoint
c        print*,'iopt_wavemaker      ',iopt_wavemaker
c        print*,'iopt_RaichlenWedge  ',iopt_RaichlenWedge
c        print*,'iopt_FloatingBodies ',iopt_FloatingBodies
c        print*,'ngate_ini, ngate_end ',ngate_ini, ngate_end
c        print*
c        call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
c      end if
c      !stop

      if(i_midPoint.gt.0)then       

        if(iopt_gate.eq.1)         call movingGate	 
        if(iopt_wavemaker.eq.1)    call movingPaddle(0) !arguement is an integer
        if(iopt_RaichlenWedge.eq.1)call movingWedge

      endif

      if(iopt_FloatingBodies.eq.1.and.itime.gt.0)then
        call rigid_body_motion(i_midPoint)
      endif
      
      return
      end


